#!/usr/bin/env ruby
# 'rbchise.so' ext compatible library by eto 2003-0317
# $Id: rbchise.rb,v 1.1 2003-11-10 08:31:26 eto Exp $
# Copyright (C) 2002-2003 Kouichirou Eto, All rights reserved.
# This is free software with ABSOLUTELY NO WARRANTY.
# You can redistribute it and/or modify it under the terms of the GNU GPL2.

require 'bdb'

module CHISE

  class DataSource #======================================================================
    NONE = 0
    Berkeley_DB = 1
    #DEFAULT_CHAR_DB_DIR = "/usr/local/lib/chise/char-db"
    DEFAULT_CHAR_DB_DIR = "d:/work/chise/char-db"
    def initialize(type=Berkeley_DB, location = DEFAULT_CHAR_DB_DIR)
      @type, @location = type, location
    end
    def close
    end
    def open_decofing_table(ccs)
      DecodingTable.new(self, ccs)
    end
    def open_feature_table(feature)
      FeatureTable.new(self, feature)
    end
  end

  class AttributeTable #======================================================================
    def open(from, to, real_subtpe, accessmask, modemask)
    end
    def get_value(char_id)
      @db.get(char_id)
    end
    def close
    end
  end
  
  class DecodingTable #======================================================================
    def initialize(ds, ccs)
      @ds, @ccs = ds, ccs
      #open
      @db = nil
    end
    def get_char(code_point)
      @db.get(code_point)
    end
    def close
    end
  end
  
  class FeatureTable #======================================================================
    def initialize(ds, feature)
      @ds, @feature = ds, feature
      #open
      @db = nil
    end
    def get_value(char_id)
      @db.get(char_id)
    end
    def close
    end
  end
  
  class Value #======================================================================
    def initialize(v)
      @v = v;
    end
    def to_s()      @v;    end
  end
  
end

#----------------------------------------------------------------------end.
